summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author abooksigun <abooksigun09@gmail.com>2019-08-24 07:53:40 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2019-08-24 08:23:02 +0700
commit1408f0d8921e7161cb40203d6cdf5561559a1b8c (patch)
treecc5690140f8b9ceef7391f1ea3e525695fcb08fd /development
parent67cb0aab24ad97b5174cf8cccf0d0b44fa751d92 (diff)
downloadslackbuilds-1408f0d8921e7161cb40203d6cdf5561559a1b8c.tar.gz
slackbuilds-1408f0d8921e7161cb40203d6cdf5561559a1b8c.tar.xz
development/Fennel: Added (Lisp dialect that compiles to Lua).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/Fennel/Fennel.SlackBuild112
-rw-r--r--development/Fennel/Fennel.info10
-rw-r--r--development/Fennel/README19
-rw-r--r--development/Fennel/slack-desc19
4 files changed, 160 insertions, 0 deletions
diff --git a/development/Fennel/Fennel.SlackBuild b/development/Fennel/Fennel.SlackBuild
new file mode 100644
index 0000000000..ccf60d9310
--- /dev/null
+++ b/development/Fennel/Fennel.SlackBuild
@@ -0,0 +1,112 @@
+#!/bin/sh
+
+# Slackware build script for Fennel
+# Copyright 2019 abooksigun <abooksigun09@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=Fennel
+VERSION=${VERSION:-0.2.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+install -D -m 0755 -t $PKG/usr/bin/ fennel fennel-watch.sh
+
+install -D -m 0644 -t $PKG/usr/lib$LIBDIRSUFFIX/lua/5.1 fennel.lua fennelview.fnl generate.fnl
+install -D -m 0644 fennelview.fnl.lua $PKG/usr/lib$LIBDIRSUFFIX/lua/5.1/fennelview.lua
+
+# lua 5.2 support.
+if $(lua5.2 -v &> /dev/null); then
+ sed -i '1s|lua.*|lua5.2|' fennel
+
+ install -D -m 0755 fennel $PKG/usr/bin/fennel5.2
+
+ install -D -m 0644 -t $PKG/usr/lib$LIBDIRSUFFIX/lua/5.2 fennel.lua fennelview.fnl generate.fnl
+ install -D -m 0644 fennelview.fnl.lua $PKG/usr/lib$LIBDIRSUFFIX/lua/5.2/fennelview.lua
+fi
+
+# lua 5.3 support
+if $(lua5.3 -v &> /dev/null); then
+ sed -i '1s|lua.*|lua5.3|' fennel
+
+ install -D -m 0755 fennel $PKG/usr/bin/fennel5.3
+
+ install -D -m 0644 -t $PKG/usr/lib$LIBDIRSUFFIX/lua/5.3 fennel.lua fennelview.fnl generate.fnl
+ install -D -m 0644 fennelview.fnl.lua $PKG/usr/lib$LIBDIRSUFFIX/lua/5.3/fennelview.lua
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/man/man1
+gzip -9 fennel.1
+cp fennel.1.gz $PKG/usr/man/man1
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -t $PKG/usr/doc/$PRGNAM-$VERSION api.md changelog.md CONTRIBUTING.md LICENSE lua-primer.md README.md reference.md tutorial.md
+
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/Fennel/Fennel.info b/development/Fennel/Fennel.info
new file mode 100644
index 0000000000..5f9cfefaf6
--- /dev/null
+++ b/development/Fennel/Fennel.info
@@ -0,0 +1,10 @@
+PRGNAM="Fennel"
+VERSION="0.2.1"
+HOMEPAGE="https://fennel-lang.org/"
+DOWNLOAD="https://github.com/bakpakin/Fennel/archive/0.2.1/Fennel-0.2.1.tar.gz"
+MD5SUM="8065cae54ede658f9abab41683028e8a"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="lua"
+MAINTAINER="abooksigun"
+EMAIL="abooksigun09@gmail.com"
diff --git a/development/Fennel/README b/development/Fennel/README
new file mode 100644
index 0000000000..878ff9c791
--- /dev/null
+++ b/development/Fennel/README
@@ -0,0 +1,19 @@
+Fennel is a programming language that brings together the speed, simplicity,
+and reach of Lua with the flexibility of a lisp syntax and macro system.
+
+* Full Lua compatibilty: Easily call any Lua function or library from Fennel and vice-versa.
+* Zero overhead: Compiled code should be just as or more efficient than hand-written Lua.
+* Compile-time macros: Ship compiled code with no runtime dependency on Fennel.
+* Embeddable: Fennel is a one-file library as well as an executable. Embed it in other
+ programs to support runtime extensibility and interactive development.
+
+Anywhere you can run Lua code, you can run Fennel code.
+
+Optional Dependency:
+* lua52, lua53
+Default support for all versions of Lua installed before build.
+After installation there is "fennel5.2" and "fennel5.3" executable files for the
+equivalent versions of Lua installed.
+
+* lua-readline
+For history completion
diff --git a/development/Fennel/slack-desc b/development/Fennel/slack-desc
new file mode 100644
index 0000000000..4f138a1f29
--- /dev/null
+++ b/development/Fennel/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+Fennel: Fennel (Lisp dialect that compiles to Lua.)
+Fennel:
+Fennel: Fennel is a programming language that brings together the speed,
+Fennel: simplicity, and reach of Lua with the flexibility of a lisp syntax
+Fennel: and macro system.
+Fennel:
+Fennel: Anywhere you can run Lua code, you can run Fennel code.
+Fennel:
+Fennel: Homepage: https://fennel-lang.org/
+Fennel:
+Fennel: